#ifndef BOND_ORDER6_PLANE_H
#define BOND_ORDER6_PLANE_H

/* This is a mpdule for calculating the bond order parameter for partices on a plane.
 *
 * It assumes that each particle has six nearest neighbours (so it is a measure of defects as well
 * as order.
 *
 * The prefix is BO6_
 * */


/*FUNCTION: bons order calculate: calculates the bond order parameter of each particle
 *
 *Return: pointer to a list of bond_orders
 *input: state: the current state of the system
 *input radius: the radius of the input sphere*/
double * BO6_plane_calculate (Mc_state *state, Mc_cell *cell, double *paramsG, double cutoff);
 

#endif
