#ifndef ENG_ANG_H
#define ENG_ANG_H

/*This is a module for measring the enegy og a particle as a function of how far around the 
 outer ring of a torus it is. Adapted for replica exchange. The module prefix is EA_*/

typedef struct enangstr {
	long n_bins;
        double bin_size;
	double *energies;
	long *freq;
} EA_function;

/*FUNCTION CONSTRUCT : make a new struct to store all this
 *params function: the struct to be initialised
 */

void EA_new_function(EA_function *function);

/*FUNCTION: destroy deallocate the function*/
void EA_destroy(EA_function *function);

/*FUNCTION: add_values. addes the current snapshot to the function
 *
 *param function -> the function to be added to
 *input energy_list
 *input angle list
 **/
void EA_add_value(EA_function *function, double *energy_list, double *angle_list, int length);

/*function print: prints the function to a file*/

void EA_print(EA_function *function);

/*FUNCTION :sort: sorts the funcitons from each mpi repetition into the correct ranks
 *
 * final_function: an initialised histogtam to have the data sorted into
 * functions: a list of the histgrams for each index
 * size: the total number of MPI ranks
 *
 **/
void EA_sort_functions(EA_function *final_function, EA_function *functions, int size);


#endif
