#ifndef MC_STATE_H
#define MC_STATE_H

/*a structure that contains the state of the system for basic mc simulations
 *
 *u: a pointer to an array containing the u coordintate of each particle
 *v: a pointer to an array containing the v coordinate of each particle
 *n_particles: the number of particles in the system
 */

typedef struct stmc {

	double *x;
	double *y;
	double *z;

	long n_particles;

} Mc_state;

/*perform a deep copy of stateI into stateT, destroying the current content of stateT
 *
 * param StateT: the targhet state to be copies to
 * input stateI the copyee. Will not be edited
 **/

void MCS_state_deepCopy(Mc_state *stateT, Mc_state *stateI);

/*perform a clone of stateI into the (uninitialised struct) stateT
 *
 * param StateT: the targhet state to be copies to
 * input stateI the copyee. Will not be edited
 **/

void MCS_state_clone (Mc_state *stateT, Mc_state *stateI);

/*free an MC struct*/
void MCS_end (Mc_state *state);

#endif
