/*This is the redo of the running average module. It was really good and then it got deleted
 * It handles caluclating running averages during a simulation.
 *
 * the module prefix is _RA
 */

#include"running_averageRE_h.h"
#include"std_h.h"
#include<float.h>
#include"mpi_h.h"



/*FUNCTION: constructor: Initialises the average
 *
 *
 */

void RA_new_average (Mc_average *average,char *name, int max_records, int restart) {

	average->samples_old = 0;
	average->samples = 0;
	average->max_records = max_records;
	average->total = 0;
	strcpy(average->name,name);

	if (restart) {
		average->record = 1;
		average->first = 0;
		average->average = malloc(sizeof(double)*(max_records+1));	

		FILE *fp;
		char filename[50];
		sprintf(filename,"%s_running_average.csv", name);
		int max_len = 3 + DBL_MANT_DIG - DBL_MIN_EXP;
		char buff[3 + DBL_MANT_DIG - DBL_MIN_EXP];
		
		fp = fopen(filename ,"rb");
		fseek(fp, -max_len, SEEK_END);
		fread(buff,max_len-1,1,fp);
		fclose(fp);
		buff[max_len-1] = '\0';
		char *last_newline = strrchr(buff, '\n');
		char *last_line = last_newline+1;
		average->average[0] = atof(last_line);
				
	} else {
		average->record = 0;
		average->first = 1;
		average->average = malloc(sizeof(double)*max_records);
	}

}

/*Function destructor: dellocates the construct
 *
 *
 */
void RA_destroy (Mc_average *average) {
	free(average->average);

}

/*Function: Add value: add a value to the running average
 8
*
 *
 */

 void RA_add_average(Mc_average *average, double value) {
	average->total += value;
	average->samples ++;
}

/*Function: push the latest average*/
void RA_push_average(Mc_average *average) {
	

	if (average->first) {
		average->average[average->record] = average->total / average->samples;
		average->first = 0;
	} else {
		average->average[average->record] = (average->average[average->record-1]   * 									      average->samples_old + 
									    average->total)/
					     (average->samples + average->samples_old);
	}
	average->samples_old += average->samples;
	average->samples = 0;
	average->total = 0;
	average->record++;
}

/*Function: print the averages*/
void RA_print_average(Mc_average *average) {
	int i;
	char command[50];
	sprintf(command,"%s_running_average.csv",average->name);
	FILE *fp = fopen(command,"a");
	for (i = 0; i < average->record; i++) {
		fprintf(fp,"%f\n",average->average[i]);
	}
	fclose(fp);
}


/*FUNcion sort averages: sorts the averages for replica exchange code. 
  *Does not use running average structure
  * Return : average for this rank
  * samples: the number os samples ranken by this rank
  * totals_list: the total value for each simulation index
  * size: the number of MPI ranks*/

double RE_sort_averages (long samples, double *totals_list, int size) {

	int i;
	double new_total;
	
	for (i = 0; i < size; i++) {
		MPI_Reduce (&(totals_list[i]),&new_total,1,MPI_DOUBLE,MPI_SUM,i,MPI_COMM_WORLD);
	}

	return new_total/samples;
}

