#ifndef RUNNING_AVERAGERE_H
#define RUNNING_AVERAGERE_H

/*This is the redo of the running average module. It was really good and then it got deleted
 * It handles caluclating running averages during a simulation.
 *
 * the module prefix is _RA
 */

/*Struct to hold the average*/

typedef struct rastrc {

	long samples_old;
	long samples;

	int max_records;
	int record;
	int first;	

	double total;	
	double * average;
	char name[50];

} Mc_average;

/*FUNCTION: constructor: Initialises the average
 *
 *
 */

void RA_new_average (Mc_average *average,char *name, int max_records, int restart);

/*Function destructor: dellocates the construct
 *
 *
 */
void RA_destroy (Mc_average *average);


/*Function: Add value: add a value to the running average
 *
 *
 */

 void RA_add_average(Mc_average *average, double value);

/*Function: push the latest average*/
void RA_push_average(Mc_average *average);

/*Function: print the averages*/

void RA_print_average(Mc_average *average);

/*FUNcion sort averages: sorts the averages for replica exchange code. 
  *Does not use running average structure
  * Return : average for this rank
  * samples: the number os samples ranken by this rank
  * totals_list: the total value for each simulation index
  * size: the number of MPI ranks*/

double RE_sort_averages (long samples, double *totals_list, int size);
#endif
