#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<unistd.h>
#include"keywords.c"

/* a utility for doing the weighted least squares matching for the umbrella sampled curved*/

int main(int argc, char *argv[]) {

	if (argc != 5) {
	printf("need 4 argument, the number of input files and number of lines in Nuc_scales, and the index associated with the run whose target nucleus is closest to the centre of the unweighted histogram and the nucleus step size \n");
	exit(0);
	}

	char *ptr;
	long n_windows = strtol(argv[1],&ptr,10);
	char command[20];
	int i,j,n,m;
	FILE *fp;

	long length1;
	long length2 =  strtol(argv[2],&ptr,10);

	long center = strtol(argv[3],&ptr,10);

	long step  = strtol(argv[4],&ptr,10); 

	int *samples1;
	int *samples2;
	double *curve1;
	double *curve2;
	double total;
	double offset;
	long total_samples;
	double center_offset;
	int skip = 0;

	/*read first entry into run */
	sprintf(command,"runUB");
	chdir(command);


	/*allocate arrays*/
	samples2 = malloc(length2*sizeof(int));
	curve2 = malloc(length2*sizeof(double));

	/*read in data*/
	fp = fopen("Nucleus_frequencies.csv","r");
	for (j = 0; j < length2; j++) {
		fscanf(fp,"%*d,%d\n",&samples2[j]);
	} 
	fclose(fp);
	fp = fopen("Nucleus_scaled.csv","r");
	total = 0;
	for (j = 0; j < length2; j++) {
		fscanf(fp,"%*d,%lf,",&curve2[j]);
		if (!isnan(curve2[j])&& !isinf(curve2[j]) && j != 0) {
			total += curve2[j];
		}
	} 
	fclose(fp);
	printf("totalI: %f\n",total);
	for (j=1;j<length2;j++) {
		curve2[j] = -log(curve2[j]/(total));
	}
	chdir("..");
	/*double zero = curve2[1];
	for (j = 1; j<length2; j++) {
		curve2[j] -= zero;
	}
	*/

	/*printf*/
	fp = fopen ("nuc_curve.csv","w");
	fprintf(fp,"%d,",-1);
	for (j = 0; j < length2; j++) {
		fprintf(fp,"%f,",curve2[j]);
	}
	fprintf(fp,"\n");
	fclose(fp);

	/*main loop*/
	for(i=center;i<n_windows;i++) {


		/*point old 2 at new 1*/
		if (skip == 0) {
			if(i != center) {
				free(samples1);
				free(curve1);
			}
			length1 = length2;
			samples1 = samples2;
			curve1 = curve2;
		} else {
			skip = 0;
		}		

		/*re-do 2*/
		sprintf(command,"run%d",i);
		 chdir(command);

		fp = fopen("Nucleus_frequencies.csv","r");
		while (fp == NULL) {
			i++;
			if (i > n_windows) exit(0);
			chdir("..");
			sprintf(command,"run%d",i);
		 	chdir(command);
			fp = fopen("Nucleus_frequencies.csv","r");
		}
		fclose(fp);

		/*allocate arrays*/
		samples2 = malloc(length2*sizeof(int));
		curve2 = malloc(length2*sizeof(double));

		/*read in data*/
		fp = fopen("Nucleus_frequencies.csv","r");
		for (j = 0; j < length2; j++) {
			fscanf(fp,"%*d,%d\n",&samples2[j]);
		} 
		fclose(fp);

		fp = fopen("Nucleus_scaled.csv","r");
		total = 0;
		for (j = 0; j < length2; j++) {
			fscanf(fp,"%*d,%lf,",&curve2[j]);
			if (!isnan(curve2[j]) && !isinf(curve2[j]) && j != 0) {
				total += curve2[j];
			}
		}
		fclose(fp);
		printf("total:%d %f\n",i,total);
		if (total < 0.0001) {
			chdir("..");
			skip = 1;
			continue;
		}
		for (j=1;j<length2;j++) {
			curve2[j] = -log(curve2[j]/total);
		}
		chdir("..");

		/*do averaging*/
		offset = 0;
		total_samples = 0;

		for (j = i*step - 5; j < length2 && j < length1 && j < i*step+5; j++) {
			if (j < 1) continue;
			total_samples += (long)samples1[j]*samples2[j];
			if (samples1[j]*samples2[j] != 0 && !isinf(curve2[j]) && !isinf(curve1[j])) {
				//printf("offset %lf %lf %lf \n",((double) samples1[j])*samples2[j],(curve2[j]-curve1[j]),offset   );
				offset	+= ((double)samples1[j]*samples2[j])*(curve2[j]-curve1[j]);
			}
		}

		//printf("OFFSET: %f %ld %f\n",offset,total_samples,offset/total_samples);
		offset = offset/total_samples;
		/*fix curve*/
		for (j = 0; j < length2;j++) {
			curve2[j] = curve2[j]-offset;
		}
		if (i == center) {
			center_offset = offset;
		}
		/*printf*/
		fp = fopen ("nuc_curve.csv","a");
		fprintf(fp,"%d,",i);
		for (j = 0; j < length2; j++) {
			fprintf(fp,"%f,",curve2[j]);
		}
		fprintf(fp,"\n");
		fclose(fp);

	}

free(samples1);
free(curve1);
free(samples2);
free(curve2);
return 0;
}
