/*-----------------------------------HISTOGRAMS-----------------------------------*/

/* A simple unitility for making jistogramsn in energy and number
 * of particles, suitable for Mark's histogram programme
 */

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"keywords.c"

#define E_BIN 3
#define N_MAX 700
#define E_MAX 3300

int main(int argc, char *argv[]) {

	system("mkdir 2Dhist");

	char command[50];
	/*get data*/
	FILE *fp;
	sprintf(command,"data%s/data.txt",argv[1]);
	fp = fopen(command,"r");
	double radius;
	double activity;
	double epsilon;
	long history;	

	if (fp == NULL) exit(0);

	while (read_line(fp)) {
		get_string(command,sizeof(command));
		upper_case(command);
	
		if (*command == '#') {
			continue;
		} else if (strcmp(command,"RECORDS")==0) {
			if (!get_int(&history)) exit(0);
		}  
	}
	fclose(fp);

	sprintf(command,"data%s/options%s.txt",argv[1],argv[1]);
	fp = fopen(command,"r");	

	if (fp == NULL) {
		printf("not found\n");
		exit(0);
	}

	while (read_line(fp)) {
		get_string(command,sizeof(command));
		upper_case(command);
	
		if (*command == '#') {
			continue;
		} else if (strcmp(command,"ACTIVITY")==0) {
			if (!get_double(&activity)) exit(0);
		} else if (strcmp(command,"EPSILON")==0) {
			if (!get_double(&epsilon)) exit(0);
		} else if (strcmp(command,"RADIUS")==0) {
			if (!get_double(&radius)) exit(0);
		}  
	}
	fclose(fp);
	

	/*allocate some memory for the num,energy pairs*/
	int *n_particles = (int *)malloc(sizeof(int)*history);
	double *energy = (double *)malloc(sizeof(double)*history);

	


	/*open file to be histogrammed and load up the data into mem*/
	
	int i;
	sprintf(command,"data%s/num_energy.csv",argv[1]);
	fp = fopen(command,"r");
	for (i = 0; i < history; i++) {
		fscanf(fp,"%d %*c %lf %*[\n]",&n_particles[i],&energy[i]);

	}
	fclose(fp);



	/*get memeory for histograms*/
	long **hist = (long **)malloc(sizeof(long *)*N_MAX);
	for (i = 0; i < N_MAX; i++) {
		hist[i] = (long *)malloc(sizeof(long)*(E_MAX/E_BIN));
	}


	/*----set to zero------*/
	int j;
	for (i = 0; i < N_MAX; i++) {
		for (j=0;j<(E_MAX/E_BIN); j++) {
			hist[i][j] = 0;
		}
	}


	/*---get histogram---*/
	double place;
	for (i = 0; i < history; i++) {
		place = E_BIN;
		for (j = 0; j < (E_MAX/E_BIN); j++) {
			//printf("%f,%f\n",-1*energy[i],place);
			if ((-1*energy[i]) < place) {
				hist[n_particles[i]][j]++;
				break;
			}
			place += E_BIN;
		}
	}

	double density_ave = 0;
	for(i=0;i<history;i++) {
		density_ave += n_particles[i];
	}
	density_ave = density_ave/history;
	density_ave = density_ave/(16*radius*radius);

	/*------get average density-----*/
	fp = fopen("density_average.csv","a");
	fprintf(fp,"%f,%f,%lf\n",epsilon,activity,density_ave);
	
	fclose(fp);

	/*print it out*/
	sprintf(command,"2Dhist/e%f_a%fsamp.dat",epsilon,activity);
	fp = fopen(command,"w");
	fprintf(fp,"#volume %lf\n",4*M_PI*radius*radius);
	for (i = 0; i < N_MAX; i++) {
		for (j=0;j<(E_MAX/E_BIN); j++) {
			if (hist[i][j]) {
				fprintf(fp,"%d %d %ld\n",i,j,hist[i][j]);
			}
		}
	} 	

	fclose(fp);

	sprintf(command,"e%f_a%fsamp.dat",epsilon,activity);
	fp =fopen("2Dhist/histograms.2D","a");

	fprintf(fp,"%s %f %f\n",command,epsilon,activity);

	fclose(fp);

return 0;
}
