/* FUNCTION: set_geometry changes the current geometry to the one specified
 * by the input. Should only be called once, near the start of the program
 *
 * input: string geo contains the name of the new geometry*/


/*_____functions______*/
/* FUNCTION: set_geometry changes the current geometry to the one specified
 * by the input. Should only be called once, near the start of the program.
 * for saftey: update the potenial after calling this.
 *
 * input: string geo contains the name of the new geometry*/
/*read function for geometry*/
void g_read (FILE *infile) {

	char command [50];
	char error[20];
	char geo[20];
	
	int success = 0 ;

	/*read in values*/

	if (infile == NULL) die ("Could not open options file!");
	rewind(infile);
	while (read_line(infile)) {
		get_string(command,sizeof(command));
		upper_case(command);

		if (*command =='#') {
			continue;
		} else if (strcmp(command,"GEOMETRY")==0) {
			if (!get_string(geo,sizeof(geo))) die ("Could not read radius");
			success = 1;
		}
	}


	if (success == 0) die ("could not read geometry from options file");

	upper_case(geo);
	
	if (strcmp(geo,"SPHERE")==0) {
		cartesian = s_cartesian;
		cartesian_bx = s_cartesian_bx;
		distance_NI = s_distance_NI;
		distance_NI_square = s_distance_NI_square;
		uv_coords = s_uv_coords;
		max_u = (2*M_PI);
		min_u = (0);
		bound_u = (0);
		max_v = (1.0);
		min_v = (-1.0);
		bound_v = (1);

		//read sphere//
		s_read (infile);
		
	} else if (strcmp(geo,"FLAT")==0) {

		cartesian = fl_cartesian;
		cartesian_bx = fl_cartesian_bx;
		distance_NI = fl_distance_NI;
		distance_NI_square = fl_distance_NI_square;
		uv_coords = fl_uv_coords;
		max_u = (1.0);
		min_u = (0.0);
		bound_u = (0);
		max_v = (1.0);
		min_v = (0.0);
		bound_v = (0);

		//read sphere//
		fl_read (infile);		
		
	} else {
		die ("geometry not recognised");
	}

}

