#ifndef LENNARD_JONES_H
#define LENNARD_JONES_H

/* a module for  the lennard jones potential
 *a submodule of potential.c. Probably should't be used alone
 *
 * prefix _ld*/

#include"std_h.h"
#include"mc_math_h.h"
#include"keywords.c"

/*
 FUNCTION: double lennard jones: calculates the pairwise ld potential
 * OUTPUT: ld potential in units of kt
 * INPUT: the square of the separation of the two particles
 */
double lennard_jones(double distance_2);

/*read function for lennard jones*/
void ld_read (FILE *infile);



#include"lennard_jones.c"
#endif
