void init_data ();
int read_file;

/*reads in, the length pf the simulation, record rate and	 * so on from the input file. IS CALLED FROM INITIALISE!!!*/
void init_read(FILE *infile) {

	char command [50];
	char error[20];
	char read[10];
	
	int success_m = 0 ;
	int success_r = 0;
	int success_e = 0;
	rewind(infile);

	/*read in values*/
	if (infile == NULL) die ("Could not open options file!");

	while (read_line(infile)) {
		get_string(command,sizeof(command));
		upper_case(command);

		if (*command =='#') {
			continue;
		} else if (strcmp(command,"MAXSTEPS")==0) {
			if (!get_int(&max_steps)) die ("Could not read max steps");
			success_m = 1;
		} else if (strcmp(command,"FRAMERATE")==0) {
			if (!get_int(&frame_rate)) die ("Could not read frame_rate");
			success_r = 1;
		} else if (strcmp(command,"EQUILIBRIATE")==0) {
			if (!get_int(&equilibriate)) die ("Could not read equilibriate");
			success_e = 1;
		}  else if (strcmp(command,"READFILE")==0) {
			if (!get_string(read,sizeof(read))) die ("Could not read 'readFile'");
		
		}  else if (strcmp(command,"RECORDRATE")==0) {
			if (!get_int(&record_rate)) die ("Could not read record_rate");
		
		} else if (strcmp(command,"AVERAGERATE")==0) {
			if (!get_int(&average_rate)) die ("Could not read average_rate");
		
		}
	}

	upper_case(read);
	if(strcmp(read,"YES")==0) {
		read_file = 1;
	} else {
		read_file = 0;
	}
	

	if (success_m == 0) die ("max steps not defined in options file");
	if (success_r == 0) die ("record rate not defined in options file");
	if (success_e == 0) die ("equilibriate not defined in options file");

	seedMT(time(NULL));
	randomF();

}

/*gets the starting positions of all the particles*/
void initialise (double **coord_u, double **coord_v) {

	char command[50];
	int i;
	FILE *fp;
	double rt;
	double *temptr;
	double *temptr2;
	/*------------check if continuing or new simulation------------*/
	if (read_file != 1) {
		//new simulation: initialise

		//initialise
		n_records = 0;
		*coord_u[0] = 0.001;
		*coord_v[0] = 0.001;

		//place each particle adjacent to the last one places-results in an initial agregate
		while (n_particles != n_particles_initial) {
			rt =randomF();
			if (rt < 0.5) {
				particle_move(*coord_u,*coord_v);
			} else {
				particle_add(coord_u,coord_v);
			}
			printf("%ld\n",n_particles);
		}
	} else {

		//read in the necessary data
		init_data();
		n_particles = n_particles_initial;
		temptr = realloc(*coord_u,sizeof(double)*n_particles); 

		if (temptr != NULL) {
			*coord_u = temptr;
		} else {
			die("realloc failed in add");
		}

		temptr2 = realloc(*coord_v,sizeof(double)*n_particles);
		if (temptr2 != NULL) {
			*coord_v = temptr2;
		} else {
			die("realloc failed in add");
		}
		//read in the initial conditions
		fp = fopen("final.csv","r");
		for (i=0;i<n_particles;i++) {
			fscanf(fp,"%lf %*c %lf %*[\n]",(*coord_u)+i,(*coord_v)+i);
		}
		fclose(fp);
	
	}
}


void init_data () {

	char command[20];
	char error[20];
	FILE *fp;
	double eps_temp;
	fp = fopen("data.txt","r");
	if (fp == NULL) die ("data.txt is missing");

	while (read_line(fp)) {
		get_string(command,sizeof(command));
		upper_case(command);
	
		if (*command == '#') {
			continue;
		} else if (strcmp(command,"N_PARTICLES")==0) {
			if (!get_int(&n_particles)) die ("could not bet number of particles");
		} else if (strcmp(command,"DELTA_U")==0) {
			if (!get_double(&delta_u)) die ("could not bet delta_u");
		} else if (strcmp(command,"DELTA_V")==0) {
			if (!get_double(&delta_v)) die ("could not bet delta_v");
		#ifdef MOVE_SPHERE_H
		} else if (strcmp(command,"DELTA")==0) {
			if (!get_double(&delta_cluster)) die ("could not bet delta_");
		#endif
		} else if (strcmp(command,"RECORDS")==0) {
			if (!get_int(&n_records)) die ("could not bet delta_u");
		#ifdef PT_INIT_H
		} else if (strcmp(command,"EPSILON")==0) {
			if (!get_double(&eps_temp)) {die ("could not get epsilon from data");
			} else {set_epsilon(eps_temp);}
		} else if (strcmp(command,"ITEMPERATURE")==0) {
			if (!get_int(&i_temperature)) die ("could not get i_temperature from data");
		#endif
		}
	}
	fclose(fp);

}



