#ifndef MC_INIT_H
#define MC_INIT_H

	/*a module to handle the initialisation of a simulation
	 *by checking if the simulation is ongoing and reading in or 
  	 * randomising particle locations
  	 *
         * prefix _init
	 */
	long max_steps;
	//the number of steps betweeen the times that the state of the system is recorded.
	long frame_rate;
	//the number of steps devolted to equilibriation of the system
	long equilibriate;
	// the number of records taken so far
	long n_records;
	//the number of steps between which the running average is printed
	long record_rate;
	//the number of steps between averaging events
	long average_rate;


	#include"std_h.h"
	#include"keywords.c"
	#include"energy_h.h"
	#include"move_h.h"
	#include"monte_carlo_h.h"

	/*--globals--*/
	//the total number of monte carlo moves made during the experiment
	//step of the simulation

	/*reads in, the length pf the simulation, record rate and
	 * so on from the input file. IS NOT CALLED FROM INITIALISE!!!*/
	void init_read(FILE *infile);

	/*gets the starting positions of all the particles,
	 * arguments are a malloc'd array of size 1, which will be expanded and filled
	 * as neccessary
	 */
	void initialise (double **coord_u, double **coord_v);

#include"mc_init.c"
#endif
