#ifndef MOVE_FLAT_H
#define MOVE_FLAT_H

/*
 * a module containing functions which perform special moves on a flat plane
 * a supermodule of move.c. on the plane,u and v are the x and y coordinates 
 * respectively, divided my their maximums
 *
 * The prefix is mf_ 
 */

#include"move_h.h"
#include"geometry_h.h"

#include"std_h.h"
#include"mc_math_h.h"
#include"twister.c"

/*globals*/
extern double delta_cluster;

extern double delta_spin;

/*read file */ 
void mf_read(FILE *infile);

/*read function is the same as the in in geometery.h. Remember to call
 * void g_read(infile);
 **/

/* FUNCTION: move_cluster takes a whole cluster and moves it as a whole. The new
 * position of the centre of the mass of the cluster moves arounnd the sphere
 * by an angle less than delta_cluster.
 *
 * Input int head: the index of the particle at the head of the cluster to be moved
 * Input int ll_cluster[]: a linked list. the value at the index of a given particle
 * is the index of the next particle in the list. Defines the clusters.
 * Param: double u* a pointer to the location which stores the particles u coord
 * Param: double v* a pointer to the location which stores the particles v coord
 */

void mf_move_cluster (int head, int ll_clusters[],double coord_u[],double coord_v[]);

/* FUNCTION: spin_cluster takes a whole cluster and spins it as a whole. The new
 * position of the centre of the mass of the cluster does not change
 *
 * Input int head: the index of the particle at the head of the cluster to be moved
 * Input int ll_cluster[]: a linked list. the value at the index of a given particle
 * is the index of the next particle in the list. Defines the clusters.
 * Param: double u* a pointer to the location which stores the particles u coord
 * Param: double v* a pointer to the location which stores the particles v coord
 */
void mf_spin_cluster (int head, int ll_clusters[],double coord_u[],double coord_v[]);



#include"move_flat.c"
#endif
