/*global*/

char p_potential[20];

/*read function*/
void p_read(FILE *infile) {

	g_read(infile);
	char command [50];
	char error[20];
	char poten[20];
	
	int success_p = 0 ;

	/*read in values*/

	if (infile == NULL) die ("Could not open options file!");
	rewind(infile);
	while (read_line(infile)) {
		get_string(command,sizeof(command));
		upper_case(command);

		if (*command =='#') {
			continue;
		} else if (strcmp(command,"POTENTIAL")==0) {
			if (!get_string(poten,sizeof(poten))) die ("Could not read potential");
			success_p = 1;
		}
	}



	if (success_p == 0) die ("potential not defined in options file");
	upper_case(poten);
	if (strcmp(poten,"LENNARDJONES")==0) {
		potential = lennard_jones;
		distance_pot = distance_NI_square;
		strcpy(p_potential,"LENNARDJONES");
		ld_read(infile);
	} else if (strcmp(poten,"MORSE")==0) {
		potential = morse;
		distance_pot = distance_NI;
		strcpy(p_potential,"MORSE");
		mp_read(infile);
	} else {
		die ("potential not recodnised");
	}



}

/*setters*/
void p_set_epsilon(double u) {
 

	if (strcmp(p_potential,"LENNARDJONES")==0 ) {
	    ld_epsilon = u;
	} else if (strcmp(p_potential,"MORSE")==0 ) {
	     mp_epsilon = u;
	} else {
	  die ("it's all gone wrong with setting epsilon\n");
	}
	  
}

/*getter*/
double p_get_epsilon() {

  if (strcmp(p_potential,"LENNARDJONES")==0 ) {
	    return ld_epsilon;
  } else if (strcmp(p_potential,"MORSE")==0 ) {
            return mp_epsilon;
  } else {
	  die ("can't get epsilon");
	  return 0.0;
	}
  return 0.0;
}
